/*
*  global.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef globalH
#define globalH
#include <dir.h>
#include "utility.h"
//---------------------------------------------------------------------------

const AnsiString NewMessage = "new message";
const int ComposeEditorFont = 0;
const int ComposeDialogFont = 1;
const int ComposeWindowFont = 2;

const TColor DefNoteColor = 11270389;
const int DefNoteHeight = 365;
const int DefNoteWidth = 375;
const bool DefNoteWordWrap = true;
AnsiString __fastcall DefNoteOpts();

// ini setting name for send message to directory
const AnsiString send2dirname = "send2dirmsgname";
const AnsiString send2dirmsgname = "message.txt";

const int OptsDefMessageWrap = 68;
const AnsiString OptsDefQuoteMarks = "> ";
const AnsiString OptsDefDialogFont = "Tahoma,10,r,0";
const AnsiString OptsDefWindowFont = "Tahoma,10,r,0";
const AnsiString OptsDefEditorFont = "Courier New,10,r,0";
const int OptsMaxSMTPLogLines = 500;
const int RichEditIndent = 4;  // left margin of page

const AnsiString imageexts = ".jpg .jpeg .bmp .gif .ico";
const AnsiString textexts  = ".txt .ini .msg .cmd .c .cpp .h .hpp .bas";

const UINT WM_SHOWSTATUS           = WM_USER + 101;
const UINT WM_LOGATTACHMENT        = WM_USER + 102;
const UINT WM_APPINICHANGE         = WM_USER + 103;
const UINT WM_SENDNEXTMESSAGE      = WM_USER + 104;
const UINT WM_LOADPROBLEM          = WM_USER + 105;
const UINT WM_LOADCANCEL           = WM_USER + 106;
const UINT WM_CHANGEDEFKEY         = WM_USER + 107;
const UINT WM_CLOSEWINDOW	       = WM_USER + 108;

#ifdef QS2
const UINT WM_OPENMESSAGE          = WM_USER + 118;
const UINT WM_SENDMAIL             = WM_USER + 119;
const UINT WM_NEWNOTE		       = WM_USER + 120;
const UINT WM_TAPQUEUES            = WM_USER + 121;
const UINT WM_SHOWNEWSRDRSTATUS    = WM_USER + 122;
const UINT WM_OPENINBOX			   = WM_USER + 124;
const UINT WM_DELATTACHMENT        = WM_USER + 125;
const UINT WM_FLAGMESSAGE          = WM_USER + 126;
const UINT WM_UNFLAGMESSAGE        = WM_USER + 127;
const UINT WM_SENDRETRSTATUS       = WM_USER + 128;

const UINT WM_MAILPROGRESS         = WM_USER + 129; // lp = position  wp = 0
const UINT WM_MAILSTATUS           = WM_USER + 130; // lp = status msg, wp = 0
const UINT WM_MAILLOG              = WM_USER + 131; // lp = log msg wp = 1 new line
const UINT WM_MAILCOMPLETE         = WM_USER + 132; // wp = 1 close dialog lp = 0
// mail errors
const UINT WM_MAILERROR            = WM_USER + 133; // lp = error msg, wp = 1 fatal
const UINT WM_HASMAILERROR		   = WM_USER + 134; // returns errortype 0=none, 1=smtp, 2=pop3
const UINT WM_CLEARMAILERROR	   = WM_USER + 135;
const UINT WM_SHOWMAILERROR		   = WM_USER + 136;
// smtp and pop3 dialogs
const WORD SHOWPROGRESS = 1;
const WORD HIDEPROGRESS = 2;
const WORD CLOSEDIALOG  = 1;
const WORD FATAL        = 1;
const WORD NOMAILERROR  = 0;
const WORD SMTPERROR    = 1;
const WORD POP3ERROR    = 2;
#endif

const UINT WM_DELMESSAGE           = WM_USER + 137;
const UINT WM_GETSAVEDIALOG        = WM_USER + 138;
const UINT WM_GETOPENDIALOG		   = WM_USER + 139;

//extern UINT WM_QSMESSAGE;
extern UINT WM_QSLMESSAGE; // assigned by RegisterWindowsMessage
const WORD BRINGTOFRONT           = 1; // wparam for WM_QSLMESSAGE
const WORD CHANGEDEFKEY           = 2; // wparam for WM_QSLMESSAGE
const WORD CLIPBOARDREPLY         = 3; // wparam for WM_QSLMESSAGE
const WORD CLIPBOARDREPLY_NT  	  = 4; // wparam for WM_QSLMESSAGE
const WORD COMPOSENEWMESSAGE      = 5; // wparam for WM_QSLMESSAGE

const WORD QSCOPYDATA             = 999;
const WORD QSCOPYDATA_NT   		  = 998;

AnsiString __fastcall AppDir();
AnsiString __fastcall AppIni();
AnsiString __fastcall AppDefsIni();
AnsiString __fastcall AppChm();
AnsiString __fastcall AppChmWB();
AnsiString __fastcall AppDataDir();
AnsiString __fastcall QsaDataDir();
AnsiString __fastcall AppDB();
AnsiString __fastcall AppDBTmp();
AnsiString __fastcall AppOldDB();
AnsiString __fastcall AppLicense();
void __fastcall GetNextWindowXY(TForm *Window);
bool __fastcall SetApplicationDataDirectory();

const AnsiString QSLKnownProblemsURL = "https://www.quicksilvermail.net/qslite/qslknown.html";
const AnsiString QSLUpdatePageURL = "https://www.quicksilvermail.net/qslite";

const AnsiString ghio = "ghio";
const AnsiString zax = "zax";

extern TList *windowlist;
//---------------------------------------------------------------------------
#endif
