/*
*  optionsdlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef optionsdlgsH
#define optionsdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------

bool __fastcall EditOptions(TForm *Owner, int page = 0);
bool __fastcall ConfigureMIXandHTTP(TForm *Owner);

class TOptionsDlg : public TForm
{
__published:	// IDE-managed Components
        TButton *OkBtn;
        TButton *CancelBtn;
        TFontDialog *FontDialog;
        TOpenDialog *OpenSecringDialog;
        TOpenDialog *OpenPubringDialog;
        TButton *HelpBtn;
        TPageControl *PageControl;
        TTabSheet *GeneralTab;
        TPanel *Panel1;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *Label20;
        TCheckBox *GENSubRandom;
        TCheckBox *GENGridLines;
        TEdit *GENQuoteChars;
        TEdit *GENWrap;
        TUpDown *GENWrapUpDown;
        TRadioGroup *GENOpenMessage;
        TRadioGroup *GENUserMode;
        TGroupBox *GENHideSelectors;
        TCheckBox *GENHideCompWinBox;
        TCheckBox *GENHideStatsDlgBox;
        TEdit *GENMaxLog;
        TUpDown *GENMaxLogUpDown;
        TCheckBox *GENUseSSLCert;
        TTabSheet *FontTab;
        TPanel *Panel5;
        TLabel *Label11;
        TLabel *Label9;
        TLabel *Label10;
        TPanel *Panel7;
        TLabel *EdiFont;
        TButton *EditorFontBtn;
        TPanel *Panel6;
        TLabel *DlgFont;
        TButton *DialogFontBtn;
        TPanel *Panel8;
        TLabel *WinFont;
        TButton *WindowFontBtn;
        TTabSheet *SMTPTab;
        TPanel *Panel3;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label2;
        TLabel *Label5;
        TEdit *SMTPServer;
        TEdit *SMTPPort;
        TCheckBox *SMTPAuth;
        TEdit *SMTPUserID;
        TEdit *SMTPPassword;
        TButton *SMTPProxyBtn;
        TTabSheet *PGPTab;
        TPanel *Panel9;
        TLabel *Label12;
        TLabel *Label13;
        TLabel *Label14;
        TLabel *Label22;
        TEdit *PGPSecring;
        TComboBox *PGPDefKey;
        TEdit *PGPPubring;
        TButton *BrowseSecBtn;
        TButton *BrowsePubBtn;
        TCheckBox *PGPBox;
        TCheckBox *PGPEncToDef;
        TCheckBox *PGPMaskVer;
        TEdit *PGPCacheMins;
        TUpDown *PGPCacheUpDown;
        TButton *PGPCacheClrBtn;
        TTabSheet *MixmasterTab;
        TPanel *Panel4;
        TLabel *Label1;
        TLabel *Label6;
        TCheckBox *MIXUpdate;
        TCheckBox *MIXMlistTxt;
        TCheckBox *MIXPubringMix;
        TCheckBox *MIXRlistTxt;
        TCheckBox *MIXPubringAsc;
        TComboBox *MIXUpdateFreq;
        TCheckBox *MIXDirect;
        TCheckBox *MIXTlsPreferred;
        TCheckBox *MIXMixMx;
        TButton *HTTPProxyBtn;
        TUpDown *HTTPTimeoutUpDown;
        TEdit *HTTPTimeout;
        TTabSheet *STUNTab;
        TPanel *Panel10;
        TLabel *Label15;
        TLabel *Label16;
        TLabel *Label17;
        TEdit *STUNListenIP;
        TEdit *STUNAcceptPort;
        TCheckBox *STUNKeepLog;
        TCheckBox *STUNDelay;
        TCheckBox *STUNUseCert;
        TTabSheet *ERASTab;
        TPanel *Panel11;
        TLabel *Label18;
        TLabel *Label19;
        TRadioButton *ERASRndWipe;
        TEdit *ERASPasses;
        TUpDown *ERASUpDown;
        TRadioButton *ERASGutWipe;
        TRadioButton *ERASDodWipe;
        TCheckBox *ERASBox;
        TLabel *Label21;
	TComboBox *MIXAllPingersTxt;
	TCheckBox *GENCloseSmtp;
	TCheckBox *MIXAfterBox;
	TComboBox *MIXAfterTime;
	TCheckBox *PNGUpdate;
	TComboBox *PNGUpdateFreq;
	TComboBox *MIXMixTls;
	TLabel *Label23;
	TCheckBox *NYMNewWindow;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall MIXResetBtnClick(TObject *Sender);
        void __fastcall HTTPProxyBtnClick(TObject *Sender);
        void __fastcall SMTPProxyBtnClick(TObject *Sender);
        void __fastcall MIXUpdateClick(TObject *Sender);
        void __fastcall DialogFontBtnClick(TObject *Sender);
        void __fastcall EditorFontBtnClick(TObject *Sender);
        void __fastcall WindowFontBtnClick(TObject *Sender);
        void __fastcall GENUserModeClick(TObject *Sender);
        void __fastcall PGPDefKeyDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall PGPSecringExit(TObject *Sender);
        void __fastcall PGPPubringExit(TObject *Sender);
        void __fastcall BrowseSecBtnClick(TObject *Sender);
        void __fastcall BrowsePubBtnClick(TObject *Sender);
        void __fastcall PGPDefKeyChange(TObject *Sender);
        void __fastcall PGPBoxClick(TObject *Sender);
        void __fastcall HelpBtnClick(TObject *Sender);
        void __fastcall PGPDefKeyDropDown(TObject *Sender);
        void __fastcall PGPDefKeyEnter(TObject *Sender);
        void __fastcall PGPCacheClrBtnClick(TObject *Sender);
        void __fastcall ERASBoxClick(TObject *Sender);
        void __fastcall MIXDirectClick(TObject *Sender);
        void __fastcall ERASRndWipeClick(TObject *Sender);
        void __fastcall GENQuoteCharsChange(TObject *Sender);
		void __fastcall MIXUpdateFreqChange(TObject *Sender);
		void __fastcall MIXAfterBoxClick(TObject *Sender);
	void __fastcall PNGUpdateClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
		bool saved, notify, expertmode;
		TStringList *gen, *http, *pgp, *mix, *stun, *eras, *seckeys; //, *smtp;
		__fastcall TOptionsDlg(TComponent* Owner);
		__fastcall virtual ~TOptionsDlg();
		void __fastcall SetExpertMode(bool mode);
		void __fastcall SetWindowFont();
		bool __fastcall CheckPGPSecringOk(const AnsiString &Secring);
		bool __fastcall CheckPGPPubringOk(const AnsiString &Pubring);
		void __fastcall ERASSetWipeMethod(const AnsiString &method);
		void __fastcall CheckDisableProxySelectors();
		AnsiString __fastcall ERASGetWipeMethod();
		void __fastcall SetControlPositions();
		int  __fastcall PGPLoadKeys();
		bool __fastcall GENModified();
		//bool __fastcall SMTPModified();
		bool __fastcall HTTPModified();
		bool __fastcall PGPModified();
		bool __fastcall MIXModified();
        //bool __fastcall STUNModified();
        bool __fastcall ERASModified();
        bool __fastcall Modified();
        void __fastcall Load();
        void __fastcall Save();
};

// other options not in opts dialog
// statssource ini settings
// previewsend ini settings
// statsdlg (winpos) ini settings
// smtpdlg (winpos) ini settings
// window (winpos) ini settings
// wordwrap ini settings
// maxloglines ini settings
// expertmode ini settings
// loadnew ini settings

//---------------------------------------------------------------------------
//extern PACKAGE TOptionsDlg *OptionsDlg;
//---------------------------------------------------------------------------
#endif
