/*
*  pgpcache.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef PgpCacheH
#define PgpCacheH
//---------------------------------------------------------------------------

class TPGPPassphrase : TObject
{
public:
   DWORD starttick, lasttick;
   AnsiString idtext8;
   TMemoryStream *encryptedphrase;
   __fastcall TPGPPassphrase(const AnsiString &PGPIDText8, AnsiString &phrase, int minutes);
   __fastcall virtual ~TPGPPassphrase();
   void __fastcall SetExpire(int minutes);
   bool __fastcall Expired();
};

class TPGPPassphraseCache : TObject
{
   TTimer *timer;
   TList *passphrases;
   void __fastcall OnTimer(TObject *Sender);
public:
   __fastcall TPGPPassphraseCache();
   __fastcall virtual ~TPGPPassphraseCache();
   void __fastcall Add(const AnsiString &idtext8, AnsiString &passphrase);
   bool __fastcall Get(TStrings *idtext8s, AnsiString &idtext8, AnsiString &passphrase);
   bool __fastcall Get(const AnsiString &idtext8, AnsiString &passphrase);
   TPGPPassphrase* __fastcall GetPGPPassphrase(int index);
   void __fastcall Clear();
   int __fastcall Count();
};

//---------------------------------------------------------------------------
extern TPGPPassphraseCache *PGPCache;
//---------------------------------------------------------------------------
#endif
