/*
*  pgprecipsdlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef pgprecipsdlgsH
#define pgprecipsdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "msgmans.h"
//---------------------------------------------------------------------------

bool __fastcall GetRecipientPGPPublicKeys(TForm *Owner, TStrings *Msg, AnsiString &EncryptKeys);

class TPGPrecipsDlg : public TForm
{
__published:	// IDE-managed Components
        TListView *KeyList;
        TButton *OkBtn;
        TButton *CancelBtn;
        TListView *RecipList;
        TGroupBox *GroupBox1;
        TCheckBox *Symmetric;
        TCheckBox *Primary;
        TTimer *Timer1;
        TPanel *Panel1;
        TLabel *Label1;
        TLabel *Label2;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall SymmetricClick(TObject *Sender);
        void __fastcall RecipListCustomDrawItem(TCustomListView *Sender,
          TListItem *Item, TCustomDrawState State, bool &DefaultDraw);
        void __fastcall RecipListDblClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall KeyListDblClick(TObject *Sender);
        void __fastcall RecipListDragDrop(TObject *Sender, TObject *Source,
          int X, int Y);
        void __fastcall RecipListDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
        void __fastcall PrimaryClick(TObject *Sender);
        void __fastcall KeyListCustomDrawItem(TCustomListView *Sender,
          TListItem *Item, TCustomDrawState State, bool &DefaultDraw);
private:	// User declarations
public:		// User declarations
        bool nokey;
        TStrings *msg;
        TStringList *keys, *algos;
        TColor windowfontcolor;
        TMsgManager *msgman;
        AnsiString symmetrickey, usermsg;
        __fastcall virtual TPGPrecipsDlg(TComponent* Owner);
        __fastcall virtual TPGPrecipsDlg(TComponent* Owner, TStrings *Msg);
        __fastcall virtual~TPGPrecipsDlg();
        void __fastcall AddKey(TListView *list, const AnsiString &key);
        void __fastcall InstallKeys();
        void __fastcall LoadKeys();
        void __fastcall ShowStatus(const AnsiString &statmsg);
        void __fastcall InstallKey(TListView *list, const AnsiString &key);
        void __fastcall InstallRecips();
        void __fastcall InstallRecipsKey(TListItem *item, const AnsiString &recip,
           const AnsiString &key);
        void __fastcall ParseKey(const AnsiString &key, TStrings *uids, AnsiString &keyid,
           AnsiString &type, AnsiString &size);
        bool __fastcall KeyExists(TListView *list, const AnsiString &key);
        AnsiString __fastcall GetListKey(TListView *list, int index);
        AnsiString __fastcall GetKeyID(TListView *list, int index);
        AnsiString __fastcall GetKey(TListView *list, int index);
        bool __fastcall KeyDisabled(TListView *list, int index);
        bool __fastcall KeyDisabled(const AnsiString &key);
        bool __fastcall KeyExpired(TListView *list, int index);
        bool __fastcall KeyExpired(const AnsiString &key);
        AnsiString __fastcall GetEncryptKeys();
};
//---------------------------------------------------------------------------
extern PACKAGE TPGPrecipsDlg *PGPrecipsDlg;
//---------------------------------------------------------------------------
#endif
