/*
*  qsl.cpp 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "global.h"
//---------------------------------------------------------------------------
USEFORM("aboutdlgs.cpp", AboutBox);
USEFORM("addressbkdlgs.cpp", AddressBkDlg);
USEFORM("attachdlgs.cpp", AttachDlg);
USEFORM("barremdlgs.cpp", BarRemDlg);
USEFORM("capsdlgs.cpp", CapsDlg);
USEFORM("composewins.cpp", ComposeWin);
USEFORM("contactdlgs.cpp", ContactDlg);
USEFORM("decodedlgs.cpp", DecodeWin);
USEFORM("defmsgdlgs.cpp", DefMessageDlg);
USEFORM("disposedlgs.cpp", MsgDisposeDlg);
USEFORM("draftdlgs.cpp", DraftDlg);
USEFORM("dsadlgs.cpp", DSADlg);
USEFORM("eheadersdlgs.cpp", EHeadersDlg);
USEFORM("follow2postdlgs.cpp", Follow2PostDlg);
USEFORM("inputdlgs.cpp", InputDlg);
USEFORM("klendlgs.cpp", KlenDlg);
USEFORM("logdlgs.cpp", LogDlg);
USEFORM("mailboxdlgs.cpp", MailboxDlg);
USEFORM("mainwins.cpp", QSLMainWin);
USEFORM("mixranddlgs.cpp", MixRandDlg);
USEFORM("optionsdlgs.cpp", OptionsDlg);
USEFORM("packdbdlgs.cpp", PackDBDlg);
USEFORM("pgpactdlgs.cpp", PGPactDlg);
USEFORM("pgpcpassdlgs.cpp", PGPcpassDlg);
USEFORM("pgpspassdlgs.cpp", PGPspassDlg);
USEFORM("pgprecipdlgs.cpp", PGPrecipDlg);
USEFORM("prevdlgs.cpp", PrevDlg);
USEFORM("proxydlgs2.cpp", ProxyDlg2);
USEFORM("proxymandlgs.cpp", ProxyManDlg);
USEFORM("qsdbs.cpp", DBSecModeDlg);
USEFORM("setupdlgs2.cpp", SetupDlg2);
USEFORM("smtpdlgs.cpp", SMTPDlg);
USEFORM("smtphostdlgs.cpp", SMTPHostDlg);
USEFORM("smtphostdsadlgs.cpp", SMTPHostDSADlg);
USEFORM("smtpmandlgs.cpp", SMTPManDlg);
USEFORM("statsdlgs.cpp", StatsDlg);
USEFORM("templatedlgs.cpp", TemplateDlg);
USEFORM("welcomedlgs.cpp", WelcomeDlg);
USEFORM("whistledlgs.cpp", WhistleDlg);
USEFORM("licensedlgs.cpp", LicenseDlg);
USEFORM("httpgetdlgs.cpp", HttpDefsDlg);
USEFORM("printdlgs.cpp", PrintingDlg);
USEFORM("gpg.cpp", GPGerrDlg);
USEFORM("blenddlgs.cpp", BlendDlg);
USEFORM("sigfaileddlgs.cpp", SigFailedDlg);
USEFORM("pgpdlgs2.cpp", PgpDlg);
USEFORM("pgpdpassdlgs2.cpp", PGPDPassDlg);
USEFORM("selectboxdlgs.cpp", SelectBoxDlg);
USEFORM("uninstdlgs.cpp", UninstDlg);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	WM_QSLMESSAGE = RegisterWindowMessage("WMQSLMESSAGE");
	HANDLE hWnd, QSMutex = CreateMutex(NULL, FALSE, "QSLMainWin");
	if(GetLastError() == ERROR_ALREADY_EXISTS)
	{
	   if ((hWnd = FindWindow("TQSLMainWin", NULL)) > 0)
	   {
		  PostMessage(hWnd, WM_QSLMESSAGE, BRINGTOFRONT, 0);
		  return 0;
	   }
	}

	try
	{
		Application->Initialize();
		SetApplicationMainFormOnTaskBar(Application, false);
		Application->Title = "QuickSilver Lite";
		Application->CreateForm(__classid(TQSLMainWin), &QSLMainWin);
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}

	ReleaseMutex(QSMutex);
	return 0;
}
//---------------------------------------------------------------------------
