/*
*  smtpdlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef smtpdlgsH
#define smtpdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "msgmans.h"
#include "utility.h"
#include <Menus.hpp>
#include "global.h"
#include "qsdbs.h"
//#include "stunnel.h"
#include "OverbyteIcsSmtpProt.hpp"
#include "OverbyteIcsWndControl.hpp"
#include "OverbyteIcsWSocket.hpp"
#include "OverbyteIcsLogger.hpp"
//---------------------------------------------------------------------------

bool __fastcall SendMail(TForm *Owner);
#ifdef QS2
bool __fastcall SendNewsreaderPost(TForm *Owner);
#endif

class TSMTPDlg : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TRichEdit *Display;
	TButton *CancelBtn;
	TTimer *Timer1;
	TProgressBar *ProgressBar;
	TTimer *Timer2;
	TPopupMenu *PopupMenu;
	TMenuItem *Resizedialog1;
	TMenuItem *Locksize1;
	TMenuItem *N1;
	TMenuItem *Copy1;
	TSslSmtpCli *SMTP;
	TSslContext *SslContext;
		TCheckBox *Verbose;
		TMenuItem *Selectall1;
	TIcsLogger *IcsLogger;
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall SMTP2Display(TObject *Sender, AnsiString Msg);
	void __fastcall SMTP2GetData(TObject *Sender, int LineNum, Pointer MsgLine,
	   int MaxLen, bool &More);
	void __fastcall SMTP2ProcessHeader(TObject *Sender, TStrings *HdrLines);
	void __fastcall SMTP2RequestDone(TObject *Sender, TSmtpRequest RqType, WORD ErrCode);
	void __fastcall SMTP2SessionConnected(TObject *Sender, WORD ErrCode);
	void __fastcall SMTP2SessionClosed(TObject *Sender, WORD ErrCode);
	void __fastcall CancelBtnClick(TObject *Sender);
	void __fastcall Timer2Timer(TObject *Sender);
	void __fastcall Resizedialog1Click(TObject *Sender);
	void __fastcall Locksize1Click(TObject *Sender);
	void __fastcall PopupMenuPopup(TObject *Sender);
	void __fastcall Copy1Click(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall SMTPResponse(TObject *Sender, AnsiString Msg);
	void __fastcall SMTPCommand(TObject *Sender, AnsiString Msg);
	void __fastcall VerboseClick(TObject *Sender);
	void __fastcall SMTPRcptToError(TObject *Sender, WORD ErrorCode,
	  int RcptNameIdx, TSmtpRcptToErrorAction &Action);
	void __fastcall SMTPMessageDataSent(TObject *Sender, int Size);
	void __fastcall Selectall1Click(TObject *Sender);
private:	// User declarations
	int FEhloCount;
public:	// User declarations
	TQSDB *mixqueue;
	TStrings *display;
	TMsgManager *msg;
	AnsiString orgwin, orgcap, messagekey, mpacketkey, defproxy, proxyinuse, laststatusmessage;
	bool proxyfail, preview, autoclose, canceled, cancelhandled, connecting,
		   showedexitinfo, usesslcert, tlspreferred, subranddate, failed, success,
		   inremmsg, expertmode, closesmtp;
	TStringList *feedback, *mpackets, *messages, *message, *proxy, *mixheaders,
		   *verbose, *brief, *shortlookup, *hosts, *mxhosts, *nodirect;
	int msgcount, mixcount, AllSent, fails, goods, curhost, curprobs;
	double BytesSent, BytesTotal;
	AnsiString lasterrorstr, currinreplyto;
	WORD lasterror;

	__fastcall TSMTPDlg(TComponent* Owner);
	__fastcall virtual TSMTPDlg(TComponent* Owner, TFormStyle FormStyle = fsNormal);
	__fastcall virtual~TSMTPDlg();
	bool __fastcall SendMail();
	//void __fastcall GetNextMessage();
		bool __fastcall SendMessageToDirectory(TStrings *message, AnsiString directory);
		void __fastcall Log(const AnsiString &text, bool force = false);
		void __fastcall LogLast(const AnsiString &txt, bool force = false);
		void __fastcall SaveSessionLog();
		void __fastcall ShowStatus(AnsiString text);
		void __fastcall ShowExitInfo();
		bool __fastcall SendNextMessage();
		void __fastcall SetupProxy();
		bool __fastcall Cancel();
		//bool __fastcall CheckCreateQSPem();
		void __fastcall GetHosts(TMsgManager *msg, TStringList *Hosts);
		void __fastcall GetHost(bool TOR, TStrings *Hosts, TStrings *cfg);
		bool __fastcall PrepareAndConnect();
		bool __fastcall PrepareAndConnectNextHost();
		void __fastcall HandleFailedMessageFeedback();
		void __fastcall ExceptionHandler(TObject *Sender, Exception *E);
		void __fastcall LogMixmasterResults(bool success, TStrings *feedback);
		void __fastcall ReportFailureOnDupOrBrokeChains(int tries, int cbrok, int cdupl);
		bool __fastcall EncryptMessage(TStrings *message, bool &usercancel);
		void __fastcall MassageReferences(TStrings *message);
		void __fastcall FileFccMessage();
		void __fastcall UnqueueMixmaster(const AnsiString &key, TStrings *message);
		void __fastcall UnqueueAllAndFcc();
        void __fastcall LoadMixmasterQueue(TStrings *filenames);
        AnsiString __fastcall GetErrorStr(int errcode);
		bool __fastcall CheckTrancriptForSuccess();
		// message funcs
        void virtual __fastcall WMLogAttachment(TMessage& Msg);
        void virtual __fastcall WMSendNextMessage(TMessage& Msg);
        // messagemap
        BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_LOGATTACHMENT, TMessage, WMLogAttachment)
        MESSAGE_HANDLER(WM_SENDNEXTMESSAGE, TMessage, WMSendNextMessage)
        END_MESSAGE_MAP(TForm)
};

//---------------------------------------------------------------------------
//extern PACKAGE TSMTPDlg *SMTPDlg;
//---------------------------------------------------------------------------
#endif
