/*
*  smtphostdsadlgs.cpp 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <inifiles.hpp>

#include "smtphostdsadlgs.h"
#include "global.h"
#include "utility.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSMTPHostDSADlg *SMTPHostDSADlg;

const AnsiString proxymsg =
"When you use this host in your QS message Host header, you MUST use the value "
"in the NAME field rather than the host name itself. Granted, they may be the "
"same, but nonetheless, QS keys on the name field. The correct header for this "
"host would be:\n\n";
//---------------------------------------------------------------------------

void __fastcall ShowSMTPNameAlert(TForm *Owner, const AnsiString &Name)
{
   TIniFile *ini = new TIniFile(AppIni());
   if (!ini->ReadBool("dontshow", "proxydsadlg", false))
   {
      TSMTPHostDSADlg *proxydsadlg = new TSMTPHostDSADlg(Owner);
      proxydsadlg->RichEdit1->Lines->Add("Host: " + Name);
      proxydsadlg->ShowModal();
      if (proxydsadlg->DontShow->Checked)
         ini->WriteBool("dontshow", "proxydsadlg", true);
      delete proxydsadlg;
   }
   delete ini;
}
//---------------------------------------------------------------------------

__fastcall TSMTPHostDSADlg::TSMTPHostDSADlg(TComponent* Owner)
        : TForm(Owner)
{
   PopupParent = (TForm*)Owner;
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   delete ini;
   RichEdit1->Lines->Text = proxymsg;
}
//---------------------------------------------------------------------------
