/*
*  templatedlgs.cpp 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <clipbrd.hpp>

#include "templatedlgs.h"
#include "composewins.h"
#include "msgmans.h"
#include "qsdbs.h"
#include "utility.h"
#include "global.h"
#include "help.h"
#include "inputdlgs.h"
#include "composewins.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//TTemplateDlg *TemplateDlg;
//---------------------------------------------------------------------------

AnsiString __fastcall SelectTemplate(TForm *Owner)
{
   AnsiString temp;
   TTemplateDlg *templatedlg = new TTemplateDlg(Owner);
   templatedlg->SaveName->Visible = false;
   templatedlg->Label2->Visible = false;
   templatedlg->ShowModal();
   int x = templatedlg->TempList->ItemIndex;
   if (templatedlg->ModalResult == mrOk && x >= 0)
   {
	  temp = templatedlg->TempList->Items->Strings[x];
   }
   delete templatedlg;
   return temp;
}
//---------------------------------------------------------------------------

/*AnsiString __fastcall SelectTemplate(TForm *Owner, bool &followup, bool &reply)
{
   AnsiString temp;
   TTemplateDlg *templatedlg = new TTemplateDlg(Owner);
   templatedlg->SaveName->Visible = false;
   templatedlg->Label2->Visible = false;
   templatedlg->ShowModal();
   int x = templatedlg->TempList->ItemIndex;
   if (templatedlg->ModalResult == mrOk && x >= 0)
   {
	  temp = templatedlg->TempList->Items->Strings[x];
	  followup = templatedlg->Clipboard->Checked && templatedlg->Followup->Checked;
	  reply = templatedlg->Clipboard->Checked && templatedlg->Reply->Checked;
   }
   delete templatedlg;
   return temp;
}*/
//---------------------------------------------------------------------------

AnsiString __fastcall SelectTemplateFollowup(TForm *Owner)
{
   AnsiString temp;
   TTemplateDlg *templatedlg = new TTemplateDlg(Owner);
   templatedlg->Label1->Caption = "Select a template for your followup...";
   templatedlg->SaveName->Visible = false;
   templatedlg->Label2->Visible = false;
   templatedlg->ShowModal();
   int x = templatedlg->TempList->ItemIndex;
   if (templatedlg->ModalResult == mrOk && x >= 0)
   {
	  temp = templatedlg->TempList->Items->Strings[x];
   }
   delete templatedlg;
   return temp;
}
//---------------------------------------------------------------------------

AnsiString __fastcall SelectTemplateReply(TForm *Owner)
{
   AnsiString temp;
   TTemplateDlg *templatedlg = new TTemplateDlg(Owner);
   templatedlg->Label1->Caption = "Select a template for your reply...";
   templatedlg->SaveName->Visible = false;
   templatedlg->Label2->Visible = false;
   templatedlg->ShowModal();
   int x = templatedlg->TempList->ItemIndex;
   if (templatedlg->ModalResult == mrOk && x >= 0)
   {
	  temp = templatedlg->TempList->Items->Strings[x];
   }
   delete templatedlg;
   return temp;
}
//---------------------------------------------------------------------------

/*AnsiString __fastcall SelectTemplate(TForm *Owner)
{
   AnsiString temp;
   TTemplateDlg *templatedlg = new TTemplateDlg(Owner);
   templatedlg->Label1->Caption = "Select a template for your message...";
   templatedlg->SaveName->Visible = false;
   templatedlg->Label2->Visible = false;
   templatedlg->ShowModal();
   int x = templatedlg->TempList->ItemIndex;
   if (templatedlg->ModalResult == mrOk && x >= 0)
   {
	  temp = templatedlg->TempList->Items->Strings[x];
   }
   delete templatedlg;
   return temp;
}*/
//---------------------------------------------------------------------------

AnsiString __fastcall SaveTemplateAs(TForm *Owner, AnsiString CurrName)
{
   AnsiString temp;
   TTemplateDlg *templatedlg = new TTemplateDlg(Owner);
   templatedlg->Label1->Caption = "Enter the name for your template...";
   templatedlg->SaveName->Text = CurrName;
   templatedlg->SaveName->Visible = true;
   templatedlg->Label2->Visible = true;
   templatedlg->ActiveControl = templatedlg->SaveName;
   templatedlg->OkBtn->Enabled = true;
   //templatedlg->OkBtn->Enabled = true;
   templatedlg->ShowModal();
   if (templatedlg->ModalResult == mrOk)
   {
	  assert(templatedlg->SaveName->Text != "");
	  temp = templatedlg->SaveName->Text;
   }
   delete templatedlg;
   return temp;
}
//---------------------------------------------------------------------------

__fastcall TTemplateDlg::TTemplateDlg(TComponent* Owner)
		: TForm(Owner)
{
   PopupParent = (TForm*)Owner;
   //Panel1->Top = 224;
   TIniFile *ini = new TIniFile(AppIni());
   LoadWindowPosition(this, "tempdlg", ini);
   orgwin = IntToStr(Width)+IntToStr(Height);
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   AssignFont(TempList->Font, ini->ReadString("settings", "windowfont",
	  OptsDefWindowFont));
   delete ini;

   //Label2->Left = SaveName->Left - (Label2->Width + 5);
   if (Font->Size > 11)
	  Label1->Top = 2;

   TStringList *items = new TStringList();
   DB->LoadTemplates(items);
   for (int i = 0; i < items->Count; i++)
	  TempList->Items->Add(items->Strings[i]);
   delete items;
}
//---------------------------------------------------------------------------

__fastcall TTemplateDlg::~TTemplateDlg()
{
   if (IntToStr(Width)+IntToStr(Height) != orgwin)
   {
	  TIniFile *ini = new TIniFile(AppIni());
	  SaveWindowPosition(this, "tempdlg", ini);
	  delete ini;
   }
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::Open1Click(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::TempListClick(TObject *Sender)
{
   int x = TempList->ItemIndex;
   DeleteBtn->Enabled = x >= 0;
   RenameBtn->Enabled = x >= 0;
   OkBtn->Enabled = x >= 0 || SaveName->Visible;
   if (SaveName->Visible && x >= 0)
	  SaveName->Text = TempList->Items->Strings[x];
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::FormShow(TObject *Sender)
{
   if (SaveName->Text == "")
   {
	  int i = 1; while (TempList->Items->IndexOf("template"+IntToStr(i)) >= 0)
		 i++;
	  SaveName->Text = "template"+IntToStr(i);
   }
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::Delete1Click(TObject *Sender)
{
   int x = TempList->ItemIndex;
   assert(x >= 0);
   AnsiString name = TempList->Items->Strings[x]; //.TrimLeft();

   if (MsgBox(this,
	  "Delete the template '" + name + "'. Are you sure? ",
	   MT_CONFIRM, MB_OKCANCEL) == IDOK)
   {
	  TempList->Items->Delete(x);
	  DB->DelTemplate(name);
	  OkBtn->Enabled = SaveName->Visible;
	  RenameBtn->Enabled = false;
	  DeleteBtn->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::FormCloseQuery(TObject *Sender,
	  bool &CanClose)
{
   if (ModalResult == mrOk && !SaveName->Visible && TempList->ItemIndex < 0)
   {
	  ModalResult = mrCancel;
	  return;
   }

   if (ModalResult == mrOk && SaveName->Visible && SaveName->Text.IsEmpty())
   {
	  MsgBox(this,
		 "You need to enter a name to save the template as, or click Cancel!   ",
		  MT_INFO, MB_OK);
	  CanClose = false;
	  return;
   }

   /*if (ModalResult == mrOk && TempList->ItemIndex >= 0 &&
	   Panel1->Visible && Clipboard->Checked)
   {
	  TStrings *lines = new TStringList();
	  TMsgManager *msg = new TMsgManager(lines);
	  lines->Text = ::Clipboard()->AsText;

	  if (Followup->Checked)
	  {
		 if(!msg->HasHeader("Newsgroups:") && !msg->HasHeader("Followup-To:"))
		 {
			MsgBox(this,
			  "The clipboard doesn't appear to contain a USENET article!    \n\n"
			  "Chances are you didn't include the article headers when   \n"
			  "you copied it. Please give it another try.",
			   MT_INFO, MB_OK);
			delete msg;
			delete lines;
			CanClose = false;
			return;
		 }
	  }
	  else
	  {
		 if(!msg->HasHeader("Reply-To: ") && !msg->HasHeader("From: "))
		 {
			MsgBox(this,
			  "The clipboard doesn't appear to contain an email message!    \n\n"
			  "Chances are you didn't include the message headers   \n"
			  "when you copied it. Please give it another try.",
			   MT_INFO, MB_OK);
			delete msg;
			delete lines;
			CanClose = false;
			return;
		 }
	  }
   }*/
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::PopupMenu1Popup(TObject *Sender)
{
   int x = TempList->ItemIndex;
   Delete1->Enabled = x >= 0;
   Rename1->Enabled = x >= 0;
   Resizedialog1->Enabled = BorderStyle == bsDialog;
   Locksize1->Enabled = BorderStyle == bsSizeable;
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::Resizedialog1Click(TObject *Sender)
{
   BorderStyle = bsSizeable;
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::Locksize1Click(TObject *Sender)
{
   BorderStyle = bsDialog;
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::TempListDrawItem(TWinControl *Control,
	  int Index, TRect &Rect, TOwnerDrawState State)
{
   TempList->Canvas->TextRect(Rect, Rect.Left + 5, Rect.Top - 1,
	  TempList->Items->Strings[Index]);
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::HelpClick(TObject *Sender)
{
   DisplayHtmlHelpTopic(this, "::/html/templatedlg.htm>tmpldlg");
}
//---------------------------------------------------------------------------

void __fastcall TTemplateDlg::Rename1Click(TObject *Sender)
{
   assert(TempList->ItemIndex >= 0);
   AnsiString newname, oldname = TempList->Items->Strings[TempList->ItemIndex];
   newname = GetUserInput(this, "Rename Template", "Enter new name", oldname,
	  TempList->Items);
   if (!newname.IsEmpty() && newname != oldname)
   {
	  TempList->Items->Delete(TempList->ItemIndex);
	  TempList->ItemIndex = TempList->Items->Add(newname);
	  DB->RenTemplate(oldname, newname);
   }
}
//---------------------------------------------------------------------------

